diff --git a/hw/misc/Makefile.objs b/hw/misc/Makefile.objs
index 85cfda9..cad0b4c 100644
--- a/hw/misc/Makefile.objs
+++ b/hw/misc/Makefile.objs
@@ -25,6 +25,7 @@ obj-$(CONFIG_SDM) += sdm-device.o
 obj-$(CONFIG_SDM) += sdm-communication.o
 obj-$(CONFIG_SDM) += sdm-signal.o
 obj-$(CONFIG_SDM) += sdm-platform.o
+obj-$(CONFIG_SDM) += sdm-communication-local.o
 
 obj-$(CONFIG_REALVIEW) += arm_sysctl.o
 obj-$(CONFIG_NSERIES) += cbus.o
diff --git a/hw/misc/sdm-communication-local.c b/hw/misc/sdm-communication-local.c
new file mode 100644
index 0000000..a9ce1ba
--- /dev/null
+++ b/hw/misc/sdm-communication-local.c
@@ -0,0 +1,116 @@
+/*
+ * SDM Communication Local
+ *
+ * Copyright (C) 2016 - Virtual Open Systems
+ *
+ * Author: Baptiste Reynal <b.reynal@virtualopensystems.com>
+ * 	   Christian Pinto <c.pinto@virtualopensystems.com>
+ *
+ * This work is licensed under the terms of the GNU GPL, version 2. See
+ * the COPYING file in the top-level directory.
+ */
+#include "hw/misc/sdm-communication-local.h"
+
+static int sdm_local_signal(SDMCommunication *sdmc, SDMDevice *sdm,
+        SDMSignalData *signal)
+{
+    SDMCommunicationLocal *sdmcl = SDM_COMMUNICATION_LOCAL(sdmc);
+    int id;
+    int dest;
+
+    dest = signal->slave;
+    if (!sdmcl->slaves[dest]) {
+        printf("Error unexisting slave\n");
+        return -1;
+    }
+
+    /* Find sdm ID
+     */
+    for (id=0; id<=sdmcl->num_slaves; id++) {
+        if (sdmcl->slaves[id] == sdm)
+            break;
+    }
+    /**
+     * Update slave_id field with source sdm ID
+     */
+    signal->slave = id;
+
+    while (sdm_device_notify(sdmcl->slaves[dest], signal) < 0) {
+        sleep(1);
+    }
+
+    return 0;
+}
+
+static int sdm_local_connect(SDMCommunication *sdmc, SDMDevice *sdm)
+{
+    SDMCommunicationLocal *sdmcl = SDM_COMMUNICATION_LOCAL(sdmc);
+    int id;
+
+    if (sdm_device_is_master(sdm)) {
+        sdmcl->num_slaves = sdm_device_get_num_slaves(sdm);
+        sdmcl->slaves = calloc(sdmcl->num_slaves + 1,
+                sizeof(SDMDevice *));
+        sdmcl->slaves[0] = sdm;
+    } else {
+        if (!sdmcl->slaves) {
+            printf("SDM Communication Local error : no master registered\n");
+            return -1;
+        }
+
+        id = sdm_device_accept(sdmcl->slaves[0]);
+
+        if (id < 0) {
+            printf("SDM Communication Local error : no id available\n");
+
+            return -1;
+        }
+
+        sdmcl->slaves[id] = sdm;
+    }
+
+    return 0;
+}
+
+static int sdm_local_update_num_slaves(SDMCommunication *sdmc, SDMDevice *sdm,
+            uint16_t num_slaves)
+{
+    SDMCommunicationLocal *sdmcl = SDM_COMMUNICATION_LOCAL(sdmc);
+    SDMDevice **tmp_slaves;
+
+    tmp_slaves = realloc(sdmcl->slaves, (num_slaves + 1) *
+                sizeof(SDMDevice *));
+
+    if(tmp_slaves == NULL)
+        return -1;
+
+    sdmcl->slaves = tmp_slaves;
+    sdmcl->num_slaves = num_slaves;
+    sdm_device_set_num_slaves(sdm, num_slaves);
+
+    return 0;
+}
+
+
+static void sdm_communication_local_class_init(ObjectClass *oc, void *data)
+{
+    SDMCommunicationClass *sdmck = SDM_COMMUNICATION_CLASS(oc);
+
+    sdmck->signal = sdm_local_signal;
+    sdmck->connect = sdm_local_connect;
+    sdmck->update_num_slaves = sdm_local_update_num_slaves;
+}
+
+static const TypeInfo sdm_communication_local_info = {
+    .name = TYPE_SDM_COMMUNICATION_LOCAL,
+    .parent = TYPE_SDM_COMMUNICATION,
+    .class_init = sdm_communication_local_class_init,
+    .instance_size = sizeof(SDMCommunicationLocal),
+};
+
+static void register_types(void)
+{
+    type_register_static(&sdm_communication_local_info);
+}
+
+type_init(register_types);
diff --git a/include/hw/misc/sdm-communication-local.h b/include/hw/misc/sdm-communication-local.h
new file mode 100644
index 0000000..34d1718
--- /dev/null
+++ b/include/hw/misc/sdm-communication-local.h
@@ -0,0 +1,35 @@
+/*
+ * SDM Communication Local
+ *
+ * Copyright (C) 2016 - Virtual Open Systems
+ *
+ * Author: Baptiste Reynal <b.reynal@virtualopensystems.com>
+ *
+ * This works is licensed under the terms of the GNU GPL, version 2. See
+ * the COPYING file un the top-level directory.
+ */
+#ifndef HW_SDM_COMM_LOCAL_H
+#define HW_SDM_COMM_LOCAL_H
+
+#include "hw/misc/sdm-communication.h"
+
+#define TYPE_SDM_COMMUNICATION_LOCAL "sdm-communication-local"
+#define SDM_COMMUNICATION_LOCAL(obj) \
+    OBJECT_CHECK(SDMCommunicationLocal, (obj), \
+            TYPE_SDM_COMMUNICATION_LOCAL)
+
+typedef struct SDMCommunicationLocal SDMCommunicationLocal;
+
+/**
+ * @SDMCommunicationLocal
+ *
+ * @parent: opaque parent object container
+ */
+struct SDMCommunicationLocal {
+    /* private */
+    SDMCommunication parent;
+
+    int num_slaves;
+    SDMDevice **slaves;
+};
+#endif